require('models/User.js')

UserStorage = function() {
  this._validateUsername = function(username) {
    var pass = true
    
    if (!username) {
      pass = false
    } else if (username.length < 5) { 
      pass = false
    } else if (!(/^(\w|\d)+$/i.test(username))) {
      pass = false
    }
    
    return pass
  }
  this._validateUser = function(user) {
    var pass = true
    
    if (!user) { 
      pass = false 
    } else if (!user.username) { 
      pass = false 
    } else if (typeof(user.username) == 'string') {
      pass = this._validateUsername(user.username)
    } else {
      pass = false
    }
    
    return pass
  }
  this._query = function(query) {}
}

UserStorage.prototype = {
  add: function(user, callback) { 
    if (!this._validateUser(user)) return
    
    if (this.storage) {
      this.storage.add(user.username, user)
      
      if (callback) callback(null)
    } else {
      if (callback) callback(new Error('Need implementation'))
    }
  },
  remove: function(username, callback) { 
    if (!this._validateUsername(username)) return
    
    if (this.storage) {
      this.storage.remove(username)
      
      if (callback) callback(null)
    } else {
      if (callback) callback(new Error('Need implementation'))
    }
  },
  update: function(username, user, callback) { 
    if (!this._validateUsername(username)) return
    
    if (this.storage) {
      try {
        this.storage.update(username, user)
        if (callback) callback(null)
      } catch (e) {
        if (callback) callback(new Error('User not found'), null)
      }
    } else {
      if (callback) callback(new Error('Need implementation'))
    }
  },
  get: function(username, callback) {
    if (!this._validateUsername(username)) return
    
    if (this.storage) {
      var user = Object.create(User)

      try {
        var loadObject = this.storage.get(username)
        for (var key in loadObject) {
          user[key] = loadObject[key]
        }

        if (callback) callback(null, user)
      } catch (e) {
        if (callback) callback(new Error('User not found'), null)
      }
    } else {
      if (callback) callback(new Error('Need implementation'), null)
    }
  },
  count: function(callback) { if (callback) callback(new Error('Need implementation'), null) },
  list: function(query) {
    query.setup(this._query)
    query.query()
  }
}
