var testCase = require('nodeunit').testCase

require('models/User.js')
require('utils/predicates/AggregatePredicate.js')
require('utils/predicates/RegexPredicate.js')

var users = [ User.create('llun'), User.create('sample1'), User.create('xavier') ]

module.exports = testCase({
  // Test object methods
  test_predicate: function(test) {
    var predicate1 = new RegexPredicate('username', /^l(.+)/)
    var predicate2 = new RegexPredicate('username', /^x(.+)/)
    
    var aggregatePredicate = new AggregatePredicate([predicate1, predicate2])
    test.ok(aggregatePredicate.test(users[0]))
    test.ok(aggregatePredicate.test(users[2]))
    
    test.ok(!aggregatePredicate.test(users[1]))
    
    test.done()
  }
})