var testCase = require('nodeunit').testCase

require('models/User.js')

var user

module.exports = testCase({
  setUp: function (callback) {
    user = User.create('user')
    callback()
  },
  tearDown: function (callback) {
    user = null
    callback()
  },
  // Test object methods
  test_passwd: function(test) {
    
    test.equals(user.passwd(''), false, "User can't change to empty password")
    test.ok(user.passwd('sample'), "User can change password in this form")
    test.equals(user.passwd('sample'), false, "User can't change to old password")
    
    test.done()
  },
  test_authenticate: function(test) {
    
    test.equals(user.authenticate(''), false, "User can't authenticate with blank password")

    user.passwd('new_password')
    test.ok(user.authenticate('new_password'), "User should have new password after change password")
    test.equals(user.authenticate('wrong_password'), false, 
                "Authenticate should return false when authenticate with wrong pass")
    
    test.done()
  }
})