var util = require('util')

require('core/Query.js')

FilterQuery = function(options, callback) {  
  this.options = options
  this.callback = callback
}

util.inherits(FilterQuery, Query)

FilterQuery.prototype.workwith = { 'hbase': true }
FilterQuery.prototype.action = function() {
  if (!this.options) { this.options = {} }
  
  var _scanner = this.scanner
  var _lastcall = this.callback
  var _results = []
  
  var _callback = function(err, cells) {
    if (cells) {
      if (typeof(cells) == 'object') {
        
        cells.forEach(function(cell) {
          _results.push(cell.key)
        })
        
      }
      
      _scanner.get(_callback)
    } else {
      _scanner.delete()
      if (_lastcall) _lastcall(_results)
    }
  }
  
  this.scanner.create(this.options, _callback)
}