var util = require('util')

require('core/Query.js')

PredicateQuery = function(predicate, callback) {
  this.predicate = predicate
  this.callback = callback
}

util.inherits(PredicateQuery, Query)

PredicateQuery.prototype.workwith = { "file": true }
PredicateQuery.prototype.action = function() {
  var keys = null
  try {
    keys = this.storage.get('list')
  } catch (e) {
    keys = {}
  }
  
  var results = []
  
  for (var key in keys) {
    var object = this.storage.get(key)
    if (this.predicate.test(object)) {
      results.push(key)
    }
  }
  
  if (this.callback) this.callback(results)
}